# 自制 Aime 读卡器教程

> 教程版本 v0.0.2（初版），可能有些疏漏，还请海涵。

> 相较于 v0.0.1，~~仅更新了版本号~~仅订正了一些错别字，无大差别

## 材料

### 芯片及其相关配件

整套方案必要费用约为 31 CNY

- 主控：推荐 NodeMCU-32s（最好是没焊好的，焊好的如果不改 PCB 的话得剪掉一些引脚），约 17 CNY
- 读卡芯片：推荐 PN532（焊好的或者没焊的都行），约 14 CNY
- 拓展板：[PCB 图纸](https://github.com/Sucareto/ESP32-CardReader/blob/main/PCB/Gerber_ESP32S-PN532-v2.zip) （即压缩文件 Gerber_ESP32S-PN532-v2.zip）去嘉立创上打个，如果你是新用户的话有两个免费打印的机会，一个打 promicro 拓展板，一个打这个刚好，具体教程参照群里打 promicro 拓展板的方式，这里不过多赘述，约 0 CNY

下文默认读者使用推荐的芯片

### 工具

- 针脚（没有的话可以从 mpr121 那边搞个 12 针脚的过来，然后剪掉 4 个，刚好 8 + 4，给 pn532 用，NodeMCU-32s 的话差不多一个道理）
- 焊接工具（电烙铁、焊锡）
- 剪线钳（可选，根据你主控是不是已经把引脚焊好了）

### 数据线

usb-A micro（旧的安卓数据线，不是 usb-C）一条

### 其他

焊接时请注意安全

## 流程

默认读者使用的 IDE 是 Arduino IDE

### 前置

在 IDE 中搜索并安装 FastLED 库、Adafruit PN532 库

安装 [PN532](https://github.com/elechouse/PN532) 库（即压缩文件 PN532.zip），Sketch（框架） -> include library（安装库） -> add .ZIP library （添加 .ZIP 库）

### 焊接

接下来，我们定义带有魂魄妖梦和 AIME 大字的面为正面，另一面为背面

翻到拓展板背面，将 NodeMCU-32s 和拓展板背靠背放置，接着 usb-A micro 口朝向外侧，进行比对（如果你未曾修改 PCB 设计图，应该在相应位置有个矩形框，另外一个正方形框是放 PN532 的），根据孔洞插入合适的针脚并焊接

如果你买的是焊好引脚的，就用剪线钳剪掉无法插入的引脚即可

同样地，PN532 与拓展板背靠背情况下进行比对，并焊接

### 调整拨码开关

撕开拨码开关的膜，把 1 顶到远离 ON 的一端，把 2 顶到 ON 的一段（使用 SPI 模式通信，如果你想使用 HSU 模式的话相信你一定能够自行研究，并修改相应代码）

拨码位置如图

![1.png](./1.png)

### 程序烧录

使用 usb 连接主机和主控，主控和读卡器均亮起红灯，根据游戏设置相应端口与波特率（下表摘自 https://github.com/Sucareto/Arduino-Aime-Reader）

| 代号 | 默认 COM 号 | 支持的卡 | 默认波特率 |
| - | - | - | - |
| SDDT/SDEZ | COM1 | FeliCa,MIFARE | 115200 |
| SDEY | COM2 | MIFARE | 38400 |
| SDHD | COM4 | FeliCa,MIFARE | cvt=38400,sp=115200 |
| SBZV/SDDF | COM10 | FeliCa,MIFARE | 38400 |
| SDBT | COM12 | FeliCa,MIFARE | 38400 |

#### 测试（可跳过）

使用压缩文件 reader_test.zip 中唯一的 .ino 代码（检查相应 #define 内容，如果你是 SPI 模式则无需修改，如果为 HSU 或其他，请进行/解除相应注释）并烧录，查看串口输出并检查相应问题，如果显示没能读到卡，就把 AIME 卡放上去，然后显示一串字符，即为成功。否则请自行查看错误信息并解决，或寻求帮助。

#### 正式烧录

下载代码[ESP32-CardReader](https://github.com/Sucareto/ESP32-CardReader)（或使用压缩文件 ESP32-CardReader.zip），解压并烧录

## 完成

打开游戏，请确保联网功能正常，然后进行刷卡，如果一切正常的话，恭喜你！和朋友一起快乐游玩音游吧~

## 致谢

感谢 Github 用户 Sucareto 写的代码
希望大家多多 star 以下仓库支持方案作者：
https://github.com/Sucareto/Arduino-Aime-Reader
https://github.com/Sucareto/ESP32-CardReader
